# -*- mode: ruby -*-
# vi: set ft=ruby :

# Vagrantfile API/syntax version. Don't touch unless you know what you're doing!
VAGRANTFILE_API_VERSION = "2"

# Store the servers in an associative array.
devweb01 = { 'name' => "devweb01", 'ip' => "192.168.11.10", 'hostname' => "devweb01.local"}
devweb02 = { 'name' => "devweb02", 'ip' => "192.168.11.11", 'hostname' => "devweb02.local" }
devweb03 = { 'name' => "devweb03", 'ip' => "192.168.11.12", 'hostname' => "devweb03.local" }

vms = [ devweb01, devweb02, devweb03]


Vagrant.configure(VAGRANTFILE_API_VERSION) do |config|
  # All Vagrant configuration is done here. The most common configuration
  # options are documented and commented below. For a complete reference,
  # please see the online documentation at vagrantup.com.

  # Every Vagrant virtual environment requires a box to build off of.
   config.vm.box = "base_ubuntu"
   config.vm.box_url = "https://cloud-images.ubuntu.com/vagrant/precise/current/precise-server-cloudimg-amd64-vagrant-disk1.box"
  
# The url from where the 'config.vm.box' box will be fetched if it
  # doesn't already exist on the user's system.
  # config.vm.box_url = "http://domain.com/path/to/above.box"

# Define the web farm. 
# Adapted from https://github.com/nsidc/vagrant-vsphere/issues/132



 # Define machine one -- Web Gateway
config.vm.define "devwebgw" do |devwebgw|
	devwebgw.vm.box = "base_ubuntu"
	devwebgw.vm.hostname = "devwebgw01.local"
        devwebgw.vm.network "private_network", ip: "192.168.11.5", virtualbox__intnet: true 
	# Add the front end of the web gateway to Vagrant. http://127.0.0.1:4567/ to access 
	devwebgw.vm.network :forwarded_port, guest: 80, host: 4567 

end	

# Build the three webservers based on the array values
# This part was adapted from source forge. 
vms.each do |node|
	name = node['name']
	ipaddr = node['ip']
	hostname = node['hostname']
	config.vm.define name do |node_config|
		node_config.vm.box = "base_ubuntu"
        	node_config.vm.hostname = hostname 
        	node_config.vm.network "private_network", ip: ipaddr, virtualbox__intnet: true 
	end
end



  # Create a forwarded port mapping which allows access to a specific port
  # within the machine from a port on the host machine. In the example below,
  # accessing "localhost:8080" will access port 80 on the guest machine.
  # config.vm.network :forwarded_port, guest: 80, host: 8080
  #  config.vm.network :forwarded_port, guest: 80, host: 3000
  # Create a private network, which allows host-only access to the machine
  # using a specific IP.
  # config.vm.network :private_network, ip: "192.168.33.10"

  # Create a public network, which generally matched to bridged network.
  # Bridged networks make the machine appear as another physical device on
  # your network.
  # config.vm.network :public_network

  # If true, then any SSH connections made will enable agent forwarding.
  # Default value: false
  # config.ssh.forward_agent = true

  # Share an additional folder to the guest VM. The first argument is
  # the path on the host to the actual folder. The second argument is
  # the path on the guest to mount the folder. And the optional third
  # argument is a set of non-required options.
  # config.vm.synced_folder "../data", "/vagrant_data"

  # Provider-specific configuration so you can fine-tune various
  # backing providers for Vagrant. These expose provider-specific options.
  # Example for VirtualBox:
  #
  # config.vm.provider :virtualbox do |vb|
  #   # Don't boot with headless mode
  #   vb.gui = true
  #
  #   # Use VBoxManage to customize the VM. For example to change memory:
  #   vb.customize ["modifyvm", :id, "--memory", "1024"]
  # end
  #
  # View the documentation for the provider you're using for more
  # information on available options.

  # Enable provisioning with Puppet stand alone.  Puppet manifests
  # are contained in a directory path relative to this Vagrantfile.
  # You will need to create the manifests directory and a manifest in
  # the file base.pp in the manifests_path directory.
  #
  # An example Puppet manifest to provision the message of the day:
  #
  # # group { "puppet":
  # #   ensure => "present",
  # # }
  # #
  # # File { owner => 0, group => 0, mode => 0644 }
  # #
  # # file { '/etc/motd':
  # #   content => "Welcome to your Vagrant-built virtual machine!
  # #               Managed by Puppet.\n"
  # # }
  #
 # config.vm.provision :puppet do |puppet|
 #   puppet.manifests_path = "puppet/environments/dev/modules/test/manifests"
 #   puppet.manifest_file  = "init.pp"
 # end
   config.vm.provision :puppet do |puppet|
    	# Use the puppet directory within Vagrant
	puppet.manifests_path = "puppet/manifests"
    	puppet.manifest_file  = "site.pp"
  #  	puppet.facter = { 'environment' => 'dev'}   
  #  	puppet.facter = { 'buildingName' => 'may'}   
	puppet.module_path = "puppet/modules"
 end
  # config.vm.provision :puppet
  # Enable provisioning with chef solo, specifying a cookbooks path, roles
  # path, and data_bags path (all relative to this Vagrantfile), and adding
  # some recipes and/or roles.
  #
  # config.vm.provision :chef_solo do |chef|
  #   chef.cookbooks_path = "../my-recipes/cookbooks"
  #   chef.roles_path = "../my-recipes/roles"
  #   chef.data_bags_path = "../my-recipes/data_bags"
  #   chef.add_recipe "mysql"
  #   chef.add_role "web"
  #
  #   # You may also specify custom JSON attributes:
  #   chef.json = { :mysql_password => "foo" }
  # end

  # Enable provisioning with chef server, specifying the chef server URL,
  # and the path to the validation key (relative to this Vagrantfile).
  #
  # The Opscode Platform uses HTTPS. Substitute your organization for
  # ORGNAME in the URL and validation key.
  #
  # If you have your own Chef Server, use the appropriate URL, which may be
  # HTTP instead of HTTPS depending on your configuration. Also change the
  # validation key to validation.pem.
  #
  # config.vm.provision :chef_client do |chef|
  #   chef.chef_server_url = "https://api.opscode.com/organizations/ORGNAME"
  #   chef.validation_key_path = "ORGNAME-validator.pem"
  # end
  #
  # If you're using the Opscode platform, your validator client is
  # ORGNAME-validator, replacing ORGNAME with your organization name.
  #
  # If you have your own Chef Server, the default validation client name is
  # chef-validator, unless you changed the configuration.
  #
  #   chef.validation_client_name = "ORGNAME-validator"
end
